#!/usr/bin/perl

# Perl program to rotate an image
#
#
# Fraga, April 16, 2001

$rows = 100;
$cols = 100;

for ( $i=0; $i<$rows; $i++ ) {
	for ( $j=0; $j<$cols; $j++ ) {
		$img[ $cols * $i + $j ] = 0;
	}
}

for ( $i=20; $i<80; $i++ ) {
	for ( $j=40; $j<60; $j++ ) {
		$img[ $cols * $i + $j ] = 255;
	}
}

$val = save_pgn_img ( \@img, $rows, $cols, "imagen1.pgm" );

rotate( \@img, $rows, $cols, 30 );
$val = save_pgn_img ( \@imgout, $rows, $cols, "imagen2.pgm" );


# Subroutine to save a image in ASCII PGM format
# (see pgm man pages on NETPBM package)
sub save_pgn_img (\@$$$) {  # ( @img, $rows, $cols, $filename );
	local (*myimg) = shift(@_);
	my $mycols = shift(@_);
	my $myrows = shift(@_);
	my $filename = shift(@_);

	my $n = @myimg;
	printf "$n $mycols $myrows $filename\n";

	open ( MYFILE, ">$filename" ) or return 1;

	print MYFILE "P2\n";
	print MYFILE "# file: $filename\n";
	print MYFILE "$mycols $myrows\n";
	print MYFILE "255\n";

	for ( my $i=1; $i <= $myrows*$mycols; $i++ ) {
		printf( MYFILE "%3d ", $myimg[$i-1] ); 
		if ( !($i%17) ) {
			print MYFILE "\n";
		}
	}
	close MYFILE;
	return 0;
}

sub rotate(\@$$$) {  # ( @img, $rows, $cols, $ang );
	local (*myimg) = shift(@_);
	my $myrow = shift(@_);
	my $mycol = shift(@_);
	my $myang = shift(@_);

	$cen_row = $myrow/2.0 - 0.5;  #/**** este es el centro ****/
    $cen_col = $mycol/2.0 - 0.5;

    my $row1 = $myrow-1;
    my $col1 = $mycol-1;

	$T = $myang*3.141515/180;

    $mat00 = cos( $T );
    $mat01 = -sin( $T );
	$mat10 = -$mat01;
	$mat11 = $mat00;

    for ($i=0; $i < $myrow; $i++) {
        for ($j=0; $j < $mycol; $j++) {
            $imgout[$i*$mycol + $j] = 0.0;
		}
	}
	for ($i=0; $i < $myrow; $i++) {
        $y = $i - $cen_row;
        $x = -$cen_col;
        #/** inicial point **/
        $xprime = $x*$mat00 + $y*$mat10 + $cen_col;
        $yprime = $x*$mat01 + $y*$mat11 + $cen_row;
        for ($j = 0; $j < $mycol; $j++) { # /**new point is xprime, yprime **/
            #/** Now, to interpolate **/
            $k = int($yprime);
            $l = int($xprime);
            if ($k < 0 || $l < 0 || $k >= $row1 || $l >= $col1) {
                $imgout[ $i*$mycol + $j] = 0;
			}
            else {
                $scalex = $xprime - $l;
                $scaley = $yprime - $k;
                $scale1 = 1.0 - $scalex;
                $val1 = $scalex * $myimg[$k*$mycol + $l+1] + 
						$scale1 * $myimg[$k*$mycol + $l];
                $val2 = $scalex * $myimg[($k+1)*$mycol +$l+1] + 
						$scale1 * $myimg[($k+1)* $mycol + $l];
                $imgout[ $i*$mycol + $j] = 
					$scaley * $val2 + (1.0-$scaley) * $val1;
            }
            $xprime += $mat00;
            $yprime += $mat01;
		}
	}
}

